freedombone/src/freedombone-app-gnusocial

973 lines
36 KiB
Plaintext
Raw Normal View History

2016-07-03 17:13:34 +02:00
#!/bin/bash
2018-04-08 14:30:21 +02:00
# _____ _ _
# | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
# | __| _| -_| -_| . | . | | . | . | | -_|
# |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
2016-07-03 17:13:34 +02:00
#
2018-04-08 14:30:21 +02:00
# Freedom in the Cloud
2016-07-03 17:13:34 +02:00
#
2016-10-01 21:15:48 +02:00
# gnusocial application
2016-07-03 17:13:34 +02:00
#
# License
# =======
#
2018-01-25 19:35:39 +01:00
# Copyright (C) 2014-2018 Bob Mottram <bob@freedombone.net>
2016-07-03 17:13:34 +02:00
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
2018-01-15 21:48:59 +01:00
VARIANTS='full full-vim social'
2016-07-06 17:47:55 +02:00
2016-11-14 14:42:49 +01:00
IN_DEFAULT_INSTALL=0
SHOW_ON_ABOUT=1
NOT_ON_ONION=1
GNUSOCIAL_DOMAIN_NAME=
GNUSOCIAL_CODE=
GNUSOCIAL_ONION_PORT=8087
GNUSOCIAL_REPO="https://git.gnu.io/gnu/gnu-social.git"
2018-03-06 13:47:15 +01:00
GNUSOCIAL_COMMIT='67a9c0415c395d92adeb784413bb9a88fba7347f'
GNUSOCIAL_ADMIN_PASSWORD=
GNUSOCIAL_BACKGROUND_IMAGE_URL=
GNUSOCIAL_TITLE='Pleroma FE'
# Number of months after which posts expire
GNUSOCIAL_EXPIRE_MONTHS=3
2018-05-28 15:47:12 +02:00
GNUSOCIAL_SHORT_DESCRIPTION=$'Federated microblogging'
GNUSOCIAL_DESCRIPTION=$'Federated microblogging'
GNUSOCIAL_MOBILE_APP_URL='https://f-droid.org/packages/org.mariotaku.twidere/'
gnusocial_variables=(ONION_ONLY
GNUSOCIAL_DOMAIN_NAME
GNUSOCIAL_CODE
GNUSOCIAL_WELCOME_MESSAGE
GNUSOCIAL_BACKGROUND_IMAGE_URL
2016-10-05 23:33:41 +02:00
DDNS_PROVIDER
GNUSOCIAL_TITLE
GNUSOCIAL_EXPIRE_MONTHS
2016-10-05 23:33:41 +02:00
MY_USERNAME)
function logging_on_gnusocial {
echo -n ''
}
function logging_off_gnusocial {
echo -n ''
}
function gnusocial_fix_endless_reloads {
# This fixes a bug introduced with commit 5f7032dfee1fd202c14e76a9f8b37af35d584901
# and which causes OrFox to endlessly reload the page
2018-02-27 15:11:56 +01:00
sed -i 's| && common_local_referer()||g' "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/lib/apiauthaction.php"
}
2016-10-02 12:17:01 +02:00
function remove_user_gnusocial {
remove_username="$1"
2018-02-27 15:11:56 +01:00
"${PROJECT_NAME}-pass" -u "$remove_username" --rmapp gnusocial
2016-11-19 20:17:33 +01:00
2016-10-16 20:50:56 +02:00
function_check get_completion_param
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
2018-02-27 15:11:56 +01:00
if [ -d "/var/www/$GNUSOCIAL_DOMAIN_NAME" ]; then
cd "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" || exit 236482468
php scripts/deleteprofile.php -n "$remove_username" -y
2016-10-02 00:39:56 +02:00
fi
2016-10-02 12:17:01 +02:00
}
2016-10-02 00:39:56 +02:00
2016-10-02 12:17:01 +02:00
function add_user_gnusocial {
2016-10-02 00:39:56 +02:00
new_username="$1"
new_user_password="$2"
2018-02-27 15:11:56 +01:00
"${PROJECT_NAME}-pass" -u "$new_username" -a gnusocial -p "$new_user_password"
2016-11-19 20:17:33 +01:00
2016-10-16 20:50:56 +02:00
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
2018-02-27 15:11:56 +01:00
if [ -d "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs" ]; then
cd "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" || exit 27462842
php scripts/registeruser.php -n "$new_username" -w "$new_user_password" -e "$new_username@$HOSTNAME"
"${PROJECT_NAME}-addemail" -u "$new_username" -e "noreply@$GNUSOCIAL_DOMAIN_NAME" -g gnusocial --public no
2016-10-02 00:39:56 +02:00
echo '0'
else
2016-10-02 12:17:01 +02:00
echo '1'
2016-10-02 00:39:56 +02:00
fi
}
function install_interactive_gnusocial {
2018-02-27 15:11:56 +01:00
if [ ! "$ONION_ONLY" ]; then
ONION_ONLY='no'
fi
2016-10-03 14:49:29 +02:00
if [[ $ONION_ONLY != "no" ]]; then
GNUSOCIAL_DOMAIN_NAME='gnusocial.local'
else
GNUSOCIAL_DETAILS_COMPLETE=
while [ ! $GNUSOCIAL_DETAILS_COMPLETE ]
do
2018-02-27 15:11:56 +01:00
data=$(mktemp 2>/dev/null)
2018-05-12 18:48:20 +02:00
if [[ $DDNS_PROVIDER == *"freedns"* ]]; then
dialog --backtitle $"Freedombone Configuration" \
--title $"GNU Social Configuration" \
2018-02-27 15:11:56 +01:00
--form $"\\nPlease enter your GNU Social details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
$"Domain:" 1 1 "$(grep 'GNUSOCIAL_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
2018-02-27 15:11:56 +01:00
$"Title:" 2 1 "$(grep "$GNUSOCIAL_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
$"Background image URL:" 3 1 "$(grep "$GNUSOCIAL_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
$"Code:" 4 1 "$(grep 'GNUSOCIAL_CODE' temp.cfg | awk -F '=' '{print $2}')" 4 25 33 255 \
2018-02-27 15:11:56 +01:00
2> "$data"
else
dialog --backtitle $"Freedombone Configuration" \
--title $"GNU Social Configuration" \
2018-02-27 15:11:56 +01:00
--form $"\\nPlease enter your GNU Social details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
$"Domain:" 1 1 "$(grep 'GNUSOCIAL_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
2018-02-27 15:11:56 +01:00
$"Title:" 2 1 "$(grep "$GNUSOCIAL_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
$"Background image URL:" 3 1 "$(grep "$GNUSOCIAL_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
2> "$data"
fi
sel=$?
case $sel in
2018-02-27 15:11:56 +01:00
1) rm -f "$data"
exit 1;;
255) rm -f "$data"
exit 1;;
esac
2018-02-27 15:11:56 +01:00
GNUSOCIAL_DOMAIN_NAME=$(sed -n 1p < "$data")
title=$(sed -n 2p < "$data")
if [ ${#title} -gt 1 ]; then
2018-02-27 15:11:56 +01:00
GNUSOCIAL_TITLE="$title"
fi
2018-02-27 15:11:56 +01:00
img_url=$(sed -n 3p < "$data")
if [ ${#img_url} -gt 1 ]; then
GNUSOCIAL_BACKGROUND_IMAGE_URL=$img_url
fi
2018-02-27 15:11:56 +01:00
if [ "$GNUSOCIAL_DOMAIN_NAME" ]; then
if [[ "$GNUSOCIAL_DOMAIN_NAME" == "$HUBZILLA_DOMAIN_NAME" ]]; then
GNUSOCIAL_DOMAIN_NAME=""
fi
TEST_DOMAIN_NAME=$GNUSOCIAL_DOMAIN_NAME
validate_domain_name
2018-02-27 15:11:56 +01:00
if [[ "$TEST_DOMAIN_NAME" != "$GNUSOCIAL_DOMAIN_NAME" ]]; then
GNUSOCIAL_DOMAIN_NAME=
dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
else
2018-05-12 18:48:20 +02:00
if [[ $DDNS_PROVIDER == *"freedns"* ]]; then
2018-02-27 15:11:56 +01:00
GNUSOCIAL_CODE=$(sed -n 4p < "$data")
validate_freedns_code "$GNUSOCIAL_CODE"
2018-02-27 15:11:56 +01:00
if [ ! "$VALID_CODE" ]; then
GNUSOCIAL_DOMAIN_NAME=
fi
fi
fi
fi
if [ $GNUSOCIAL_DOMAIN_NAME ]; then
GNUSOCIAL_DETAILS_COMPLETE="yes"
fi
2018-02-27 15:11:56 +01:00
rm -f "$data"
done
2016-10-17 18:54:22 +02:00
# remove any invalid characters
if [ ${#GNUSOCIAL_TITLE} -gt 0 ]; then
2018-02-27 15:11:56 +01:00
new_title=${GNUSOCIAL_TITLE//\'/}
GNUSOCIAL_TITLE="$new_title"
2016-10-17 18:54:22 +02:00
fi
# save the results in the config file
write_config_param "GNUSOCIAL_CODE" "$GNUSOCIAL_CODE"
write_config_param "GNUSOCIAL_TITLE" "$GNUSOCIAL_TITLE"
write_config_param "GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_BACKGROUND_IMAGE_URL"
fi
write_config_param "GNUSOCIAL_DOMAIN_NAME" "$GNUSOCIAL_DOMAIN_NAME"
APP_INSTALLED=1
}
2016-09-25 12:20:41 +02:00
function change_password_gnusocial {
2016-11-20 13:37:13 +01:00
curr_username="$1"
new_user_password="$2"
2017-05-23 16:49:08 +02:00
read_config_param 'GNUSOCIAL_DOMAIN_NAME'
2016-11-20 13:37:13 +01:00
2018-02-27 15:11:56 +01:00
cd "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/scripts" || exit 246824642
2016-12-04 13:28:45 +01:00
php setpassword.php "$curr_username" "$new_user_password"
2016-11-20 13:37:13 +01:00
2018-02-27 15:11:56 +01:00
"${PROJECT_NAME}-pass" -u "$curr_username" -a gnusocial -p "$new_user_password"
}
function gnusocial_create_database {
2018-02-27 15:11:56 +01:00
if [ -f "$IMAGE_PASSWORD_FILE" ]; then
GNUSOCIAL_ADMIN_PASSWORD="$(printf "%s" "$(cat "$IMAGE_PASSWORD_FILE")")"
2016-11-19 10:37:35 +01:00
else
2018-02-27 15:11:56 +01:00
if [ ! "$GNUSOCIAL_ADMIN_PASSWORD" ]; then
GNUSOCIAL_ADMIN_PASSWORD="$(create_password "${MINIMUM_PASSWORD_LENGTH}")"
2016-09-25 12:20:41 +02:00
fi
fi
2018-02-27 15:11:56 +01:00
if [ ! "$GNUSOCIAL_ADMIN_PASSWORD" ]; then
2016-09-25 12:20:41 +02:00
return
fi
function_check create_database
2018-02-27 15:11:56 +01:00
create_database gnusocial "$GNUSOCIAL_ADMIN_PASSWORD" "$MY_USERNAME"
}
2016-07-09 12:36:12 +02:00
function reconfigure_gnusocial {
2016-09-25 12:20:41 +02:00
echo -n ''
2016-07-09 12:36:12 +02:00
}
2016-10-20 21:55:59 +02:00
function gnusocial_set_background_image {
2017-04-04 00:27:10 +02:00
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
2018-02-27 15:11:56 +01:00
data=$(mktemp 2>/dev/null)
2016-10-20 21:55:59 +02:00
dialog --title $"GNU Social" \
--backtitle $"Freedombone Control Panel" \
2018-02-27 15:11:56 +01:00
--inputbox $'Set a background image URL' 10 60 2>"$data"
2016-10-20 21:55:59 +02:00
sel=$?
case $sel in
0)
2018-02-27 15:11:56 +01:00
temp_background=$(<"$data")
2016-10-20 21:55:59 +02:00
if [ ${#temp_background} -gt 0 ]; then
GNUSOCIAL_BACKGROUND_IMAGE_URL="$temp_background"
write_config_param "GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_BACKGROUND_IMAGE_URL"
2018-02-27 15:11:56 +01:00
if [[ $(pleroma_set_background_image_from_url "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" "$GNUSOCIAL_DOMAIN_NAME" "$GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_TITLE" | tail -n 1) == "0" ]]; then
2016-10-20 21:55:59 +02:00
dialog --title $"Set GNU Social login background" \
--msgbox $"The background image has been set" 6 60
fi
fi
;;
esac
2018-02-27 15:11:56 +01:00
rm -f "$data"
2016-10-20 21:55:59 +02:00
}
function gnusocial_set_title {
2018-02-27 15:11:56 +01:00
data=$(mktemp 2>/dev/null)
2016-10-20 21:55:59 +02:00
dialog --title $"GNU Social" \
--backtitle $"Freedombone Control Panel" \
2018-02-27 15:11:56 +01:00
--inputbox $'Set a title' 10 60 2>"$data"
2016-10-20 21:55:59 +02:00
sel=$?
case $sel in
0)
2018-02-27 15:11:56 +01:00
new_title=$(<"$data")
if [ ${#new_title} -gt 0 ]; then
GNUSOCIAL_TITLE="$new_title"
2017-04-04 11:47:06 +02:00
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
write_config_param "GNUSOCIAL_TITLE" "$GNUSOCIAL_TITLE"
2018-02-27 15:11:56 +01:00
cd "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/static" || exit 246824242
sed -i "s|\"name\":.*|\"name\": \"${GNUSOCIAL_TITLE}\",|g" config.json
dialog --title $"Set GNU Social title" \
--msgbox $"The title has been set" 6 60
2016-10-20 21:55:59 +02:00
fi
;;
esac
2018-02-27 15:11:56 +01:00
rm -f "$data"
2016-10-20 21:55:59 +02:00
}
function gnusocial_set_expire_months {
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
read_config_param "GNUSOCIAL_EXPIRE_MONTHS"
2018-02-27 15:11:56 +01:00
data=$(mktemp 2>/dev/null)
dialog --title $"GNU Social" \
--backtitle $"Freedombone Control Panel" \
2018-02-27 15:11:56 +01:00
--inputbox $'Set an expiry period for posts in months. Anything older will be deleted. Lower values help to keep the database size small and as fast as possible.' 12 60 "$GNUSOCIAL_EXPIRE_MONTHS" 2>"$data"
sel=$?
case $sel in
0)
2018-02-27 15:11:56 +01:00
new_expiry_months=$(<"$data")
if [ ${#new_expiry_months} -gt 0 ]; then
# should contain no spaces
if [[ "$new_expiry_months" == *" "* ]]; then
2018-02-27 15:11:56 +01:00
rm -f "$data"
return
fi
# should be a number
re='^[0-9]+$'
if ! [[ $new_expiry_months =~ $re ]] ; then
2018-02-27 15:11:56 +01:00
rm -f "$data"
return
fi
# set the new value
GNUSOCIAL_EXPIRE_MONTHS=$new_expiry_months
write_config_param "GNUSOCIAL_EXPIRE_MONTHS" "$GNUSOCIAL_EXPIRE_MONTHS"
expire_gnusocial_posts "$GNUSOCIAL_DOMAIN_NAME" "gnusocial" "$GNUSOCIAL_EXPIRE_MONTHS"
dialog --title $"Set GNU Social post expiry period" \
--msgbox $"Expiry period set to $GNUSOCIAL_EXPIRE_MONTHS months" 6 60
fi
;;
esac
2018-02-27 15:11:56 +01:00
rm -f "$data"
}
2016-10-20 21:55:59 +02:00
function configure_interactive_gnusocial {
2017-08-10 14:20:11 +02:00
read_config_param GNUSOCIAL_EXPIRE_MONTHS
2016-10-20 21:55:59 +02:00
while true
do
W=(1 $"Set a background image"
2 $"Set the title"
3 $"Set post expiry period (currently $GNUSOCIAL_EXPIRE_MONTHS months)"
4 $"Select Qvitter user interface"
5 $"Select Pleroma user interface"
6 $"Select Classic user interface")
2018-04-04 13:42:18 +02:00
# shellcheck disable=SC2068
selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"GNU Social" --menu $"Choose an operation, or ESC to exit:" 15 60 6 "${W[@]}" 3>&2 2>&1 1>&3)
if [ ! "$selection" ]; then
break
fi
case $selection in
2016-10-20 21:55:59 +02:00
1) gnusocial_set_background_image;;
2) gnusocial_set_title;;
3) gnusocial_set_expire_months;;
4) gnusocial_use_qvitter gnusocial;;
5) gnusocial_use_pleroma gnusocial;;
6) gnusocial_use_classic gnusocial;;
2016-10-20 21:55:59 +02:00
esac
done
}
2016-07-06 16:01:28 +02:00
function upgrade_gnusocial {
2017-06-12 23:40:33 +02:00
CURR_GNUSOCIAL_COMMIT=$(get_completion_param "gnusocial commit")
if [[ "$CURR_GNUSOCIAL_COMMIT" == "$GNUSOCIAL_COMMIT" ]]; then
return
fi
2018-02-27 15:11:56 +01:00
if grep -q "gnusocial domain" "$COMPLETION_FILE"; then
2016-10-16 20:50:56 +02:00
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
2016-09-25 12:20:41 +02:00
fi
2016-07-06 16:40:09 +02:00
2016-09-25 12:20:41 +02:00
# update to the next commit
function_check set_repo_commit
2018-02-27 15:11:56 +01:00
set_repo_commit "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" "gnusocial commit" "$GNUSOCIAL_COMMIT" "$GNUSOCIAL_REPO"
2016-07-06 16:40:09 +02:00
gnusocial_fix_endless_reloads
# Ensure that installation script is removed
2018-02-27 15:11:56 +01:00
if [ -f "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/install.php" ]; then
rm "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/install.php"
fi
2018-02-27 15:11:56 +01:00
if [ -f "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/index_qvitter.php" ]; then
if [ -f "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/index.php" ]; then
# shellcheck disable=SC2086
mv /var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/index.php /var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/index_qvitter.php
2017-04-05 00:10:20 +02:00
fi
fi
gnusocial_block_user_script
2018-02-27 15:11:56 +01:00
gnusocial_block_domain_script gnusocial "$GNUSOCIAL_DOMAIN_NAME"
2018-02-27 15:11:56 +01:00
gnusocial_hourly_script gnusocial "$GNUSOCIAL_DOMAIN_NAME"
if [ -d "$INSTALL_DIR/pleroma" ]; then
2017-11-06 12:29:20 +01:00
upgrade_pleroma_frontend "$GNUSOCIAL_DOMAIN_NAME" "gnusocial" "$GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_TITLE"
2017-06-12 23:40:33 +02:00
fi
install_gnusocial_default_background "gnusocial" "$GNUSOCIAL_DOMAIN_NAME"
2018-02-27 15:11:56 +01:00
chown -R www-data:www-data "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs"
2016-07-06 16:01:28 +02:00
}
2016-07-06 16:40:09 +02:00
2016-07-06 15:55:09 +02:00
function backup_local_gnusocial {
GNUSOCIAL_DOMAIN_NAME='gnusocial'
2018-02-27 15:11:56 +01:00
if grep -q "gnusocial domain" "$COMPLETION_FILE"; then
2016-10-16 20:50:56 +02:00
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
2016-09-25 12:20:41 +02:00
fi
2016-07-07 12:20:10 +02:00
2017-07-09 18:06:07 +02:00
# don't backup more data than we need to
2017-08-13 12:28:59 +02:00
/etc/cron.daily/gnusocial-expire
2017-07-09 18:06:07 +02:00
2018-02-27 15:11:56 +01:00
source_directory="/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/backup"
if [ ! -d "$source_directory" ]; then
mkdir "$source_directory"
fi
2018-02-27 15:11:56 +01:00
cp -p "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/config.php" "$source_directory"
if [ -d "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/static" ]; then
cp -rp "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/static" "$source_directory"
fi
2016-07-07 12:20:10 +02:00
function_check suspend_site
2018-02-27 15:11:56 +01:00
suspend_site "${GNUSOCIAL_DOMAIN_NAME}"
2016-07-07 12:20:10 +02:00
function_check backup_directory_to_usb
dest_directory=gnusocialconfig
2018-02-27 15:11:56 +01:00
backup_directory_to_usb "$source_directory" "$dest_directory"
2016-07-07 12:20:10 +02:00
2018-02-27 15:11:56 +01:00
source_directory="/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/file"
dest_directory=gnusocialfile
2018-02-27 15:11:56 +01:00
backup_directory_to_usb "$source_directory" "$dest_directory"
function_check backup_database_to_usb
backup_database_to_usb gnusocial
function_check restart_site
restart_site
2016-07-06 15:55:09 +02:00
}
function restore_local_gnusocial {
2018-02-27 15:11:56 +01:00
if ! grep -q "gnusocial domain" "$COMPLETION_FILE"; then
2016-09-25 12:20:41 +02:00
return
fi
2016-10-16 20:50:56 +02:00
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
2018-02-27 15:11:56 +01:00
if [ "$GNUSOCIAL_DOMAIN_NAME" ]; then
2016-10-01 21:15:48 +02:00
echo $"Restoring gnusocial"
2016-09-25 12:20:41 +02:00
temp_restore_dir=/root/tempgnusocial
2018-02-27 15:11:56 +01:00
gnusocial_dir="/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs"
2016-09-25 12:20:41 +02:00
# stop the daemons
2018-02-27 15:11:56 +01:00
cd "$gnusocial_dir" || exit 24627248428
2017-06-03 18:49:23 +02:00
scripts/stopdaemons.sh
2016-09-25 12:20:41 +02:00
function_check gnusocial_create_database
gnusocial_create_database
restore_database gnusocial
2016-09-25 12:20:41 +02:00
if [ -d $temp_restore_dir ]; then
rm -rf $temp_restore_dir
fi
function_check restore_directory_from_usb
restore_directory_from_usb $temp_restore_dir gnusocialconfig
if [ -d $temp_restore_dir ]; then
2018-02-27 15:11:56 +01:00
if [ -d "$temp_restore_dir$gnusocial_dir" ]; then
cp "$temp_restore_dir$gnusocial_dir/backup/config.php" "$gnusocial_dir/"
cp -rp "$temp_restore_dir$gnusocial_dir/static" "$gnusocial_dir/"
else
2018-02-27 15:11:56 +01:00
cp "$temp_restore_dir/backup/config.php" "$gnusocial_dir/"
if [ ! -d "$gnusocial_dir/static" ]; then
mkdir "$gnusocial_dir/static"
fi
2018-03-03 12:49:17 +01:00
cp -rp "$temp_restore_dir/static/"* "$gnusocial_dir/static/"
fi
2018-02-27 15:11:56 +01:00
chown www-data:www-data "$gnusocial_dir/config.php"
chown -R www-data:www-data "$gnusocial_dir/static"
rm -rf $temp_restore_dir
fi
restore_directory_from_usb $temp_restore_dir gnusocialfile
2018-02-27 15:11:56 +01:00
if [ -d "$temp_restore_dir" ]; then
if [ -d "$temp_restore_dir$gnusocial_dir/file" ]; then
cp -rp "$temp_restore_dir$gnusocial_dir/file" "$gnusocial_dir/"
else
2018-02-27 15:11:56 +01:00
if [ ! -d "$gnusocial_dir/file" ]; then
mkdir "$gnusocial_dir/file"
fi
2018-03-03 12:49:17 +01:00
cp -rp "$temp_restore_dir/"* "$gnusocial_dir/file"
fi
2018-02-27 15:11:56 +01:00
chown -R www-data:www-data "$gnusocial_dir/file"
rm -rf "$temp_restore_dir"
fi
2018-02-27 15:11:56 +01:00
gnusocial_update_after_restore gnusocial "${GNUSOCIAL_DOMAIN_NAME}"
2017-06-25 18:29:10 +02:00
2016-10-01 21:15:48 +02:00
echo $"Restore of gnusocial complete"
2016-09-25 12:20:41 +02:00
fi
}
2016-07-06 15:55:09 +02:00
function backup_remote_gnusocial {
GNUSOCIAL_DOMAIN_NAME='gnusocial'
2018-02-27 15:11:56 +01:00
if grep -q "gnusocial domain" "$COMPLETION_FILE"; then
2016-10-16 20:50:56 +02:00
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
fi
2017-07-09 18:06:07 +02:00
# don't backup more data than we need to
2017-08-13 12:28:59 +02:00
/etc/cron.daily/gnusocial-expire
2017-07-09 18:06:07 +02:00
source_directory=/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/backup
2018-02-27 15:11:56 +01:00
if [ ! -d "$source_directory" ]; then
mkdir "$source_directory"
fi
2018-02-27 15:11:56 +01:00
cp -p "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/config.php" "$source_directory"
if [ -d "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/static" ]; then
cp -rp "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/static" "$source_directory"
fi
2016-09-25 12:20:41 +02:00
function_check suspend_site
2018-02-27 15:11:56 +01:00
suspend_site "${GNUSOCIAL_DOMAIN_NAME}"
2016-09-25 12:20:41 +02:00
function_check backup_directory_to_friend
dest_directory=gnusocialconfig
2018-02-27 15:11:56 +01:00
backup_directory_to_friend "$source_directory" "$dest_directory"
2016-09-25 12:20:41 +02:00
source_directory=/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/file
dest_directory=gnusocialfile
2018-02-27 15:11:56 +01:00
backup_directory_to_friend "$source_directory" "$dest_directory"
2016-09-25 12:20:41 +02:00
function_check backup_database_to_friend
backup_database_to_friend gnusocial
function_check restart_site
restart_site
2016-07-04 22:02:22 +02:00
}
function restore_remote_gnusocial {
2018-02-27 15:11:56 +01:00
if ! grep -q "gnusocial domain" "$COMPLETION_FILE"; then
return
fi
GNUSOCIAL_DOMAIN_NAME=$(get_completion_param "gnusocial domain")
2018-02-27 15:11:56 +01:00
if [ "$GNUSOCIAL_DOMAIN_NAME" ]; then
2016-10-01 21:15:48 +02:00
echo $"Restoring gnusocial"
temp_restore_dir=/root/tempgnusocial
gnusocial_dir=/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs
2016-09-25 12:20:41 +02:00
# stop the daemons
2018-02-27 15:11:56 +01:00
cd "$gnusocial_dir" || exit 2468246824
2017-06-03 18:49:23 +02:00
scripts/stopdaemons.sh
2016-09-25 12:20:41 +02:00
function_check gnusocial_create_database
gnusocial_create_database
function_check restore_database_from_friend
restore_database_from_friend gnusocial
if [ -d $temp_restore_dir ]; then
rm -rf $temp_restore_dir
fi
function_check restore_directory_from_friend
restore_directory_from_friend $temp_restore_dir gnusocialconfig
if [ -d $temp_restore_dir ]; then
2018-02-27 15:11:56 +01:00
if [ -d "$temp_restore_dir$gnusocial_dir" ]; then
cp "$temp_restore_dir$gnusocial_dir/backup/config.php" "$gnusocial_dir/"
cp -rp "$temp_restore_dir$gnusocial_dir/static" "$gnusocial_dir/"
else
2018-02-27 15:11:56 +01:00
cp "$temp_restore_dir/backup/config.php" "$gnusocial_dir/"
if [ ! -d "$gnusocial_dir/static" ]; then
mkdir "$gnusocial_dir/static"
fi
2018-03-03 12:49:17 +01:00
cp -rp "$temp_restore_dir/static/"* "$gnusocial_dir/static/"
fi
2018-02-27 15:11:56 +01:00
chown www-data:www-data "$gnusocial_dir/config.php"
chown -R www-data:www-data "$gnusocial_dir/static"
rm -rf $temp_restore_dir
fi
restore_directory_from_friend $temp_restore_dir gnusocialfile
if [ -d $temp_restore_dir ]; then
2018-02-27 15:11:56 +01:00
if [ ! -d "$temp_restore_dir$gnusocial_dir/file" ]; then
cp -rp "$temp_restore_dir$gnusocial_dir/file" "$gnusocial_dir/"
else
2018-02-27 15:11:56 +01:00
if [ ! -d "$gnusocial_dir/file" ]; then
mkdir "$gnusocial_dir/file"
fi
2018-03-03 12:49:17 +01:00
cp -rp "$temp_restore_dir/"* "$gnusocial_dir/file/"
fi
2018-02-27 15:11:56 +01:00
chown -R www-data:www-data "$gnusocial_dir/file"
rm -rf $temp_restore_dir
2016-09-25 12:20:41 +02:00
fi
2018-02-27 15:11:56 +01:00
gnusocial_update_after_restore gnusocial "${GNUSOCIAL_DOMAIN_NAME}"
2017-06-25 18:29:10 +02:00
2016-10-01 21:15:48 +02:00
echo $"Restore of gnusocial complete"
2016-09-25 12:20:41 +02:00
fi
}
2016-07-05 21:07:43 +02:00
function remove_gnusocial {
if [ ${#GNUSOCIAL_DOMAIN_NAME} -eq 0 ]; then
return
fi
function_check remove_nodejs
remove_nodejs pleroma-gnusocial
read_config_param "GNUSOCIAL_DOMAIN_NAME"
2016-10-14 15:56:14 +02:00
read_config_param "MY_USERNAME"
echo "Removing $GNUSOCIAL_DOMAIN_NAME"
2018-02-27 15:11:56 +01:00
nginx_dissite "$GNUSOCIAL_DOMAIN_NAME"
remove_certs "$GNUSOCIAL_DOMAIN_NAME"
if [ -f /etc/cron.hourly/gnusocial-daemons ]; then
rm /etc/cron.hourly/gnusocial-daemons
fi
2018-02-27 15:11:56 +01:00
if [ -f "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/stopdaemons.sh" ]; then
cd "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" || exit 2648244287
2017-06-03 18:49:23 +02:00
scripts/stopdaemons.sh
2016-10-27 20:56:57 +02:00
fi
2018-02-27 15:11:56 +01:00
kill_pid=$(pgrep "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/queuedaemon.php" | head -n 1)
kill -9 "$kill_pid"
pkill "$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/queuedaemon.php"
2018-02-27 15:11:56 +01:00
if [ -d "/var/www/$GNUSOCIAL_DOMAIN_NAME" ]; then
rm -rf "/var/www/$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
fi
2018-02-27 15:11:56 +01:00
if [ -f "/etc/nginx/sites-available/$GNUSOCIAL_DOMAIN_NAME" ]; then
rm "/etc/nginx/sites-available/$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
fi
function_check drop_database
drop_database gnusocial
function_check remove_onion_service
remove_onion_service gnusocial ${GNUSOCIAL_ONION_PORT}
2016-10-01 14:14:39 +02:00
if grep -q "gnusocial" /etc/crontab; then
sed -i "/gnusocial/d" /etc/crontab
2016-10-01 12:55:56 +02:00
fi
remove_app gnusocial
2016-10-17 15:44:49 +02:00
remove_completion_param install_gnusocial
2018-02-27 15:11:56 +01:00
sed -i '/gnusocial/d' "$COMPLETION_FILE"
2016-11-02 18:49:21 +01:00
remove_backup_database_local gnusocial
2017-08-06 18:12:03 +02:00
if grep -q 'gnusocial-firewall' /etc/crontab; then
sed -i '/gnusocial-firewall/d' /etc/crontab
fi
sed -i 's|mysqli.allow_persistent.*|mysqli.allow_persistent = On|g' /etc/php/7.0/cli/php.ini
sed -i 's|mysqli.reconnect.*|mysqli.reconnect = Off|g' /etc/php/7.0/cli/php.ini
if [ -f /usr/bin/gnusocial-firewall ]; then
rm /usr/bin/gnusocial-firewall
fi
if [ -f /etc/cron.daily/gnusocial-expire ]; then
rm /etc/cron.daily/gnusocial-expire
fi
if [ -f /usr/bin/gnusocial-expire-posts ]; then
rm /usr/bin/gnusocial-expire-posts
fi
function_check remove_ddns_domain
2018-02-27 15:11:56 +01:00
remove_ddns_domain "$GNUSOCIAL_DOMAIN_NAME"
2016-07-03 22:22:12 +02:00
}
2016-07-05 22:50:11 +02:00
function install_gnusocial_main {
2018-02-27 15:11:56 +01:00
if [ ! "$GNUSOCIAL_DOMAIN_NAME" ]; then
echo $'No domain name was given for gnusocial'
2016-09-25 12:20:41 +02:00
exit 7359
fi
2016-09-30 22:38:44 +02:00
if [[ $(app_is_installed gnusocial_main) == "1" ]]; then
2016-09-25 12:20:41 +02:00
return
fi
2018-02-27 15:11:56 +01:00
gnusocial_hourly_script gnusocial "$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
function_check install_mariadb
install_mariadb
function_check get_mariadb_password
get_mariadb_password
function_check repair_databases_script
repair_databases_script
2017-05-29 15:40:34 +02:00
apt-get -yq install php-gettext php-curl php-gd php-mysql git curl
2017-06-04 10:42:16 +02:00
apt-get -yq install memcached php-memcached php-intl exiftool libfcgi0ldbl
2016-09-25 12:20:41 +02:00
2018-02-27 15:11:56 +01:00
if [ ! -d "/var/www/$GNUSOCIAL_DOMAIN_NAME" ]; then
mkdir "/var/www/$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
fi
2018-02-27 15:11:56 +01:00
if [ ! -d "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" ]; then
2017-06-15 13:33:16 +02:00
if [ -d /repos/gnusocial ]; then
2018-02-27 15:11:56 +01:00
mkdir "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs"
cp -r -p /repos/gnusocial/. "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs"
cd "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" || exit 24682628424
2017-06-15 13:33:16 +02:00
git pull
else
function_check git_clone
2018-02-27 15:11:56 +01:00
git_clone "$GNUSOCIAL_REPO" "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs"
2017-06-15 13:33:16 +02:00
fi
2018-02-27 15:11:56 +01:00
if [ ! -d "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" ]; then
2016-09-25 12:20:41 +02:00
echo $'Unable to clone gnusocial repo'
exit 87525
fi
fi
2018-02-27 15:11:56 +01:00
cd "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" || exit 26482468482
git checkout "$GNUSOCIAL_COMMIT" -b "$GNUSOCIAL_COMMIT"
2016-10-16 20:50:56 +02:00
set_completion_param "gnusocial commit" "$GNUSOCIAL_COMMIT"
2016-09-25 12:20:41 +02:00
gnusocial_fix_endless_reloads
2018-02-27 15:11:56 +01:00
chmod g+w "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs"
chmod a+w "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/avatar"
chmod a+w "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/file"
chown -R www-data:www-data "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs"
chmod +x "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/maildaemon.php"
2016-09-25 12:20:41 +02:00
function_check gnusocial_create_database
gnusocial_create_database
if [ ! -f "/etc/aliases" ]; then
touch /etc/aliases
fi
if ! grep -q "www-data: root" /etc/aliases; then
echo 'www-data: root' >> /etc/aliases
fi
if ! grep -q "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/maildaemon.php" /etc/aliases; then
echo "*: /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/scripts/maildaemon.php" >> /etc/aliases
2016-09-25 12:20:41 +02:00
fi
function_check add_ddns_domain
2018-02-27 15:11:56 +01:00
add_ddns_domain "$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
GNUSOCIAL_ONION_HOSTNAME=$(add_onion_service gnusocial 80 ${GNUSOCIAL_ONION_PORT})
gnusocial_nginx_site=/etc/nginx/sites-available/$GNUSOCIAL_DOMAIN_NAME
2016-09-25 12:20:41 +02:00
if [[ $ONION_ONLY == "no" ]]; then
function_check nginx_http_redirect
2018-02-27 15:11:56 +01:00
nginx_http_redirect "$GNUSOCIAL_DOMAIN_NAME" "index index.php"
{ echo 'server {';
echo ' listen 443 ssl;';
echo ' #listen [::]:443 ssl;';
echo " server_name $GNUSOCIAL_DOMAIN_NAME;";
echo ''; } >> "$gnusocial_nginx_site"
function_check nginx_compress
2018-02-27 15:11:56 +01:00
nginx_compress "$GNUSOCIAL_DOMAIN_NAME"
echo '' >> "$gnusocial_nginx_site"
echo ' # Security' >> "$gnusocial_nginx_site"
2016-09-25 12:20:41 +02:00
function_check nginx_ssl
2018-02-27 15:11:56 +01:00
nginx_ssl "$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
2018-03-05 19:15:29 +01:00
function_check nginx_security_options
nginx_security_options "$GNUSOCIAL_DOMAIN_NAME"
2018-02-27 15:11:56 +01:00
{ echo ' add_header Strict-Transport-Security max-age=15768000;';
echo '';
echo ' # Logs';
echo ' access_log /dev/null;';
echo ' error_log /dev/null;';
echo '';
echo ' # Root';
echo " root /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs;";
echo '';
echo ' # Index';
echo ' index index.php;';
echo '';
echo ' # PHP';
echo ' location ~ \.php {';
echo ' client_max_body_size 50m;';
echo ' client_body_buffer_size 50m;';
2018-02-27 15:11:56 +01:00
echo ' include snippets/fastcgi-php.conf;';
echo ' fastcgi_pass unix:/var/run/php/php7.0-fpm.sock;';
echo ' fastcgi_read_timeout 30;';
echo ' }';
echo '';
echo ' # Location';
echo ' location / {'; } >> "$gnusocial_nginx_site"
2016-10-01 13:18:23 +02:00
function_check nginx_limits
2018-02-27 15:11:56 +01:00
nginx_limits "$GNUSOCIAL_DOMAIN_NAME" '15m'
{ echo " try_files \$uri \$uri/ @gnusocial;";
echo ' }';
echo '';
echo ' # Fancy URLs';
echo ' location @gnusocial {';
echo ' client_max_body_size 50m;';
echo ' client_body_buffer_size 50m;';
2018-02-27 15:11:56 +01:00
echo " rewrite ^(.*)\$ /index.php?p=\$1 last;";
echo ' }';
echo '';
echo ' # Restrict access that is unnecessary anyway';
echo ' location ~ /\.(ht|git) {';
echo ' deny all;';
echo ' }';
echo '}'; } >> "$gnusocial_nginx_site"
2016-09-25 12:20:41 +02:00
else
2018-02-27 15:11:56 +01:00
echo -n '' > "$gnusocial_nginx_site"
2016-09-25 12:20:41 +02:00
fi
2018-02-27 15:11:56 +01:00
{ echo 'server {';
echo " listen 127.0.0.1:$GNUSOCIAL_ONION_PORT default_server;";
echo " server_name $GNUSOCIAL_ONION_HOSTNAME;";
echo ''; } >> "$gnusocial_nginx_site"
function_check nginx_compress
2018-02-27 15:11:56 +01:00
nginx_compress "$GNUSOCIAL_DOMAIN_NAME"
echo '' >> "$gnusocial_nginx_site"
2018-03-05 19:15:29 +01:00
function_check nginx_security_options
nginx_security_options "$GNUSOCIAL_DOMAIN_NAME"
2018-02-27 15:11:56 +01:00
{ echo '';
echo ' # Logs';
echo ' access_log /dev/null;';
echo ' error_log /dev/null;';
echo '';
echo ' # Root';
echo " root /var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs;";
echo '';
echo ' # Index';
echo ' index index.php;';
echo '';
echo ' # PHP';
echo ' location ~ \.php {';
echo ' client_max_body_size 50m;';
echo ' client_body_buffer_size 50m;';
2018-02-27 15:11:56 +01:00
echo ' include snippets/fastcgi-php.conf;';
echo ' fastcgi_pass unix:/var/run/php/php7.0-fpm.sock;';
echo ' fastcgi_read_timeout 30;';
echo ' }';
echo '';
echo ' # Location';
echo ' location / {'; } >> "$gnusocial_nginx_site"
2016-10-01 13:18:23 +02:00
function_check nginx_limits
2018-02-27 15:11:56 +01:00
nginx_limits "$GNUSOCIAL_DOMAIN_NAME" '15m'
{ echo " try_files \$uri \$uri/ @gnusocial;";
echo ' }';
echo '';
echo ' # Fancy URLs';
echo ' location @gnusocial {';
echo ' client_max_body_size 50m;';
echo ' client_body_buffer_size 50m;';
2018-02-27 15:11:56 +01:00
echo " rewrite ^(.*)\$ /index.php?p=\$1 last;";
echo ' }';
echo '';
echo ' # Restrict access that is unnecessary anyway';
echo ' location ~ /\.(ht|git) {';
echo ' deny all;';
echo ' }';
echo '}'; } >> "$gnusocial_nginx_site"
2016-09-25 12:20:41 +02:00
function_check gnusocial_set_limits
gnusocial_set_limits "$gnusocial_nginx_site"
2016-09-25 12:20:41 +02:00
function_check configure_php
configure_php
function_check create_site_certificate
2018-02-27 15:11:56 +01:00
create_site_certificate "$GNUSOCIAL_DOMAIN_NAME" 'yes'
2016-09-25 12:20:41 +02:00
# Ensure that the database gets backed up locally, if remote
# backups are not being used
function_check backup_databases_script_header
backup_databases_script_header
function_check backup_database_local
backup_database_local gnusocial
function_check nginx_ensite
2018-02-27 15:11:56 +01:00
nginx_ensite "$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
# NOTE: For the typical case always enable SSL and only
# disable it if in onion only mode. This is due to complexities
2016-10-01 21:15:48 +02:00
# with the way URLs are generated by gnusocial
2016-09-25 12:20:41 +02:00
gnusocial_ssl='always'
if [[ $ONION_ONLY != 'no' ]]; then
gnusocial_ssl='never'
fi
GNUSOCIAL_SERVER=${GNUSOCIAL_DOMAIN_NAME}
2016-09-25 12:20:41 +02:00
if [[ $ONION_ONLY != 'no' ]]; then
GNUSOCIAL_SERVER=${GNUSOCIAL_ONION_HOSTNAME}
2016-09-25 12:20:41 +02:00
fi
# Create the configuration
2018-02-27 15:11:56 +01:00
gnusocial_installer="/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/scripts/install_cli.php"
if [ ! -f "$gnusocial_installer" ]; then
rm -rf "/var/www/$GNUSOCIAL_DOMAIN_NAME"
2016-10-01 21:15:48 +02:00
echo $'No gnusocial commandline installer found'
2016-09-25 12:20:41 +02:00
exit 53026
fi
${gnusocial_installer} --server "${GNUSOCIAL_SERVER}" \
2016-09-25 12:20:41 +02:00
--host="localhost" --database="gnusocial" \
--dbtype=mysql --username="root" -v \
--password="$MARIADB_PASSWORD" \
--sitename=$"GNU Social" --fancy='yes' \
--admin-nick="$MY_USERNAME" \
--admin-pass="$GNUSOCIAL_ADMIN_PASSWORD" \
2016-09-25 12:20:41 +02:00
--site-profile="community" \
--ssl=${gnusocial_ssl}
# There can be a lot of warnings here so the return value check is disabled
#if [ ! "$?" = "0" ]; then
# # failed to install
# echo $'Could not install GNU Social'
# exit 72357
#fi
# check gnusocial has a config file
2018-02-27 15:11:56 +01:00
gnusocial_config_file="/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/config.php"
if [ ! -f "$gnusocial_config_file" ]; then
2016-12-01 12:17:33 +01:00
drop_database gnusocial
2018-02-27 15:11:56 +01:00
rm -rf "/var/www/$GNUSOCIAL_DOMAIN_NAME"
echo $'Gnusocial config.php not found'
2016-09-25 12:20:41 +02:00
exit 87586
fi
# Some useful settings
2018-02-27 15:11:56 +01:00
if ! grep -q "Recommended GNU social settings" "$gnusocial_config_file"; then
{ echo "";
echo "// Recommended GNU social settings";
echo "\$config['thumbnail']['maxsize'] = 3000;";
echo "\$config['profile']['delete'] = true;";
echo "\$config['profile']['changenick'] = true;";
echo "\$config['public']['localonly'] = false;";
echo "addPlugin('StoreRemoteMedia');";
echo "\$config['queue']['enabled'] = true;";
echo "\$config['queue']['daemon'] = true;";
echo "\$config['ostatus']['hub_retries'] = 3;"; } >> "$gnusocial_config_file"
2016-09-25 12:20:41 +02:00
fi
2016-11-18 15:43:19 +01:00
# turn off logging
2018-02-27 15:11:56 +01:00
echo "\$config['site']['logfile'] = '/dev/null';" >> "$gnusocial_config_file"
echo "\$config['mail']['domain'] = '${DEFAULT_DOMAIN_NAME}';" >> "$gnusocial_config_file"
2016-11-18 15:43:19 +01:00
2016-09-25 12:20:41 +02:00
# This improves performance
2018-02-27 15:11:56 +01:00
sed -i "s|//\$config\\['db'\\]\\['schemacheck'\\].*|\$config\\['db'\\]\\['schemacheck'\\] = 'script';|g" "$gnusocial_config_file"
2016-09-25 12:20:41 +02:00
# remove the install script
if [ -f "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/install.php" ]; then
rm "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs/install.php"
fi
# php configuration
sed -i 's|mysqli.allow_persistent.*|mysqli.allow_persistent = On|g' /etc/php/7.0/cli/php.ini
sed -i 's|mysqli.reconnect.*|mysqli.reconnect = On|g' /etc/php/7.0/cli/php.ini
2017-06-06 15:26:57 +02:00
systemctl restart mariadb
2017-06-01 20:05:15 +02:00
systemctl restart php7.0-fpm
2016-09-25 12:20:41 +02:00
systemctl restart nginx
2018-02-27 15:11:56 +01:00
"${PROJECT_NAME}-addemail" -u "$MY_USERNAME" -e "noreply@$GNUSOCIAL_DOMAIN_NAME" -g gnusocial --public no
2016-09-25 12:20:41 +02:00
2018-02-27 15:11:56 +01:00
"${PROJECT_NAME}-pass" -u "$MY_USERNAME" -a gnusocial -p "$GNUSOCIAL_ADMIN_PASSWORD"
gnusocial_block_user_script
gnusocial_block_domain_script gnusocial "$GNUSOCIAL_DOMAIN_NAME"
2016-10-01 12:55:56 +02:00
2016-10-16 20:50:56 +02:00
set_completion_param "gnusocial domain" "$GNUSOCIAL_DOMAIN_NAME"
2016-09-25 12:20:41 +02:00
2016-09-30 22:38:44 +02:00
install_completed gnusocial_main
2016-07-03 17:13:34 +02:00
}
2016-07-05 22:50:11 +02:00
function install_gnusocial {
if [[ "$ONION_ONLY" != 'no' ]]; then
return
fi
2016-09-25 12:20:41 +02:00
install_gnusocial_main
expire_gnusocial_posts "$GNUSOCIAL_DOMAIN_NAME" "gnusocial" "$GNUSOCIAL_EXPIRE_MONTHS"
install_qvitter "$GNUSOCIAL_DOMAIN_NAME" "gnusocial"
2017-06-18 14:19:55 +02:00
install_gnusocial_markdown "$GNUSOCIAL_DOMAIN_NAME" "gnusocial"
2017-06-18 13:59:56 +02:00
install_gnusocial_plugin_sharings "$GNUSOCIAL_DOMAIN_NAME" "gnusocial"
install_gnusocial_plugin_sharings_theme "$GNUSOCIAL_DOMAIN_NAME" "gnusocial"
# Currently Pleroma won't install on ARM systems
# because it uses node-sass which doesn't support ARM
if [[ "$(arch)" == "arm"* || "$(arch)" == "aarch"* ]]; then
2017-04-02 18:35:05 +02:00
echo -m $'WARNING: Pleroma currently does not support ARM '
echo $'architecture, so it will not be installed'
else
function_check install_nodejs
install_nodejs pleroma-gnusocial
install_pleroma_front_end "gnusocial" "$GNUSOCIAL_DOMAIN_NAME" "$GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_TITLE"
install_gnusocial_default_background "gnusocial" "$GNUSOCIAL_DOMAIN_NAME"
2018-02-27 15:11:56 +01:00
sed -i 's|"theme":.*|"theme": "base16-apathy.css",|g' "/var/www/${GNUSOCIAL_DOMAIN_NAME}/htdocs/static/config.json"
fi
2018-05-08 19:58:16 +02:00
# this has to be run as root initially, otherwise database tables
# don't get created
2018-03-06 13:47:15 +01:00
cd "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" || exit 236482684
php scripts/checkschema.php
2018-05-08 19:58:16 +02:00
sh scripts/startdaemons.sh
/etc/cron.hourly/gnusocial-daemons
2017-04-05 14:28:56 +02:00
systemctl restart nginx
2017-06-16 11:09:05 +02:00
# Set qvitter to be the default UI. It's probably the most stable.
# And doesn't forget logins
gnusocial_use_qvitter gnusocial
2018-02-27 15:11:56 +01:00
if [ "$GNUSOCIAL_BACKGROUND_IMAGE_URL" ]; then
pleroma_set_background_image_from_url "/var/www/$GNUSOCIAL_DOMAIN_NAME/htdocs" "$GNUSOCIAL_DOMAIN_NAME" "$GNUSOCIAL_BACKGROUND_IMAGE_URL" "$GNUSOCIAL_TITLE"
2017-06-18 14:26:49 +02:00
fi
APP_INSTALLED=1
2016-07-03 17:13:34 +02:00
}
# NOTE: deliberately there is no "exit 0"